function vE = convertBasis10E(p, E, N)
% converts the integer p into a vector vE of length N, containing integers between 1 and E+1 representing p in basis E+1
% convention: vE(1) represents the idiosyncratic  state in the present period and vE(N) represents the past idosyncratic state N-1 periods before


if ~((p>=1)&&(p<=(E+1)^N))
    warning('incompatible integer p');
    return;
end

ptemp = p-1;
vE = zeros(1,N);r=0;
for k=1:N 
    r = mod(ptemp, E+1);
    vE(N-k+1) = 1+r;
    ptemp = fix((ptemp-r)/(E+1));
end

