function p = convertBasisE10(vE, E, N)
% converts the a vector vE into an integer p 
% vE is of length N, containing integers between 1 and E+1 
% p is the decimal represention of v (which is in basis E+1)
% convention: vE(1) represents the idiosyncratic  state in the present period and vE(N) represents the past idosyncratic state N-1 periods before


if (length(vE)~=N)
    warning('incompatible length for vE');
    return;
end

if ~(all(vE>=1))
    warning('all elements of vE should be >= 1');
    return;
end

if ~(all(vE<=E+1))
    warning('all elements of vE should be <= E+1');
    return;
end

%v = vE - 1;
p = 0;
%for k=N:(-1):1
for k=1:N
    p = p+(vE(k)-1)*(E+1)^(N-k);
end

p=p+1;%otherwise between 0 and (E+1)^N - 1



