function write_dynare_simul(bewley,proj,periods)
warning('off','all');
load exo_process
 

Ntot        = length(proj.lambda);
Nb          = proj.Nbin;
Ny          = length(bewley.ex);
S           = proj.lambda;

apv         = proj.ap(:)./proj.lambda;
atv         = proj.a(:)./proj.lambda;

for i = find(proj.lambda==0)
    apv(i)            = 0;
    atv(i)            = 0;    
end;



Transpa     = proj.Transpa;     % Matrix from i to (b,y) (before labor market transition) (backward) CORRECTION for numerical accuracy
Transp      = proj.Transp;
Transpu     = proj.Transpu;
Nbin        = proj.Nbin;
thres       = 10^-6;            % threshold to consider that the bin is too smal to be simulated  (not to have too many equations, can check that it doesn't affect the dynamics)
coefS       = 0.99999;        % Technical oefficient to insure BK condition (conraction on sizes)
if proj.method==2
    coefa    = 1;             % Sometimes BK doesn't work with implicit partition, in this case impose a contraction 0.995 for instance
else 
    coefa    = 1;
end;
coefE        = 1;
coefp        = 1;% time-varying phi
phil         = bewley.phil;
xsil         = bewley.xsil;
Uc           = @(C,l) (C - (l.^(1+1/phil))/(xsil*(1+1/phil))).^(-bewley.sigma);
if bewley.sigma == 1
    U        = @(C,l) log(C - (l.^(1+1/bewley.phil))/(xsil*(1+1/phil)));
else
    U        = @(C,l) (((C - (l.^(1+1/phil))/(xsil*(1+1/phil)))).^(1-bewley.sigma))/(1-bewley.sigma);
end
rho_u       = 0.95;
sigma_u     = 0.006579;
fid         = fopen('Dynare_simul.mod', 'w') ;
formatSpec  = '%16.12f';


% in this version I consider the given transition on the labor market and
% correlation from the regressions
means       = bewley.pie(2,1);
meanf       = bewley.pie(1,2);

str         = ['var\n'] ; fprintf(fid, str);
str         = ['r w Z K GDP L U tau u Pop  s f C Ce Cu ratio LGDP LC LI LL Lw\n'] ; fprintf(fid, str);
str         = ['cec cuc Ku Incu kuc dY dK dL dC du Ineq df dU dphi I L2\n'] ; fprintf(fid, str);

%str         = ['r w Z K GDP L U tau u Pop DIF phi s f C Ce Cu ratio\n'] ; fprintf(fid, str);


for i = 1:Ntot
    str     = ['ap',num2str(i),' '] ; fprintf(fid,str);    
    str     = ['at',num2str(i),' '] ; fprintf(fid, str);           
    str     = ['c',num2str(i),' '] ; fprintf(fid, str);  
    str     = ['S',num2str(i),' '] ; fprintf(fid, str);
    
    if mod(i,10)==0; %multiple de 10
        str = ['\n'] ;         fprintf(fid, str);
    end;    
end;
for i = 1:proj.nx
    str     = ['l',num2str(i),' '] ; fprintf(fid, str);      
    if mod(i,10)==0; %multiple de 10
        str = ['\n'] ;         fprintf(fid, str);
    end;    
end;
str         = ['; \n\n'] ; fprintf(fid, str);

str         = ['varexo eps; \n\n'] ; fprintf(fid, str);
str         = ['parameters\n'] ; fprintf(fid, str);
str         = ['beta alpha abar delta sigma rho_u xsil phil  phi \n'] ; fprintf(fid, str);
str = ['; \n\n'] ; fprintf(fid, str);

l0          = bewley.pie(2,1);
abar        = min(bewley.kgrid);
 
str         = ['alpha','   = ',num2str(proj.alpha),';\n']; fprintf(fid, str); 
str         = ['beta ','   = ',num2str(proj.beta),';\n']; fprintf(fid, str); 
str         = ['abar ','   = ',num2str(abar),';\n']; fprintf(fid, str); 
str         = ['sigma','   = ',num2str(proj.sigma),';\n']; fprintf(fid, str); 
str         = ['rho_u','   = ',num2str(rho_u),';\n']; fprintf(fid, str); %HERE
str         = ['delta','   = ',num2str(proj.delta),';\n']; fprintf(fid, str);
str         = ['l    ','   = ',num2str(l0),';\n']; fprintf(fid, str);
str         = ['phil ','   = ',num2str(bewley.phil),';\n']; fprintf(fid, str);
str         = ['xsil ','   = ',num2str(bewley.xsil),';\n']; fprintf(fid, str);
str         = ['phi  ','   = ',num2str(proj.phi),';\n']; fprintf(fid, str);

str         = ['\n\n'] ; fprintf(fid, str);


    for i = 1:Ntot
            bv(i)   =  1 + mod(i-1,Nb);
            if i <= Ntot/2
                ev(i)   = 1;
            else
                ev(i)   = 2;
            end;
            yv(i) = 1+(i - bv(i)  - (ev(i)-1)*Ny*Nb)/Nb;
    end
if Ny==1
    yv  =   1 +0*yv';
end;
    

str     = ['%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'] ; fprintf(fid, str); 
str     = ['\n\n'] ; fprintf(fid, str);    

str     = ['model;\n\n']; fprintf(fid, str);
equa    = 1;
%%%%%%%%%%%%%%%%% LABOR SUPPLY %%%%%%%%%%%%%
for i = 1:proj.nx
    str = ['l',num2str(i),' =  (',num2str(proj.ex(i)*bewley.xsil,formatSpec),'*(1-tau)*w)^',num2str(bewley.phil),';']; fprintf(fid, str);
    str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
end;
%%%%%%%%%%%%%%%%% BUDGET CONSTRAINTS %%%%%%%%%%%%%
for i = 1:Ntot/2
    str = ['c',num2str(i),'+ap',num2str(i), ' = phi*w*',num2str(bewley.ex(yv(i)),formatSpec),'*l',num2str(yv(i)),' + (1+r)*at',num2str(i),';']; fprintf(fid, str);
    str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
end;
for i = Ntot/2+1:Ntot
    str = ['c',num2str(i),'+ap',num2str(i), ' = (1-tau)*w*',num2str(bewley.ex(yv(i)),formatSpec),'*l',num2str(yv(i)),'+ (1+r)*at',num2str(i),';']; fprintf(fid, str);
    str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
end;
str = ['\n\n']; fprintf(fid, str);
%%%%%%%%%%%%%%%%  WEALTH TRANSITION  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i = 1:Ntot/2
   if S(i)>thres 
     str = ['at',num2str(i),' = (1/S',num2str(i),')*(\n']; fprintf(fid, str);
     emp = 1;
     for j=1:Ntot/2         % u to u
         if Transpa(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+ ',num2str(coefa*Transpa(i,j)/(1-meanf),formatSpec),'*(1-f)*S',num2str(j),'(-1)*ap',num2str(j),'(-1)\n']; fprintf(fid, str);            
             emp = 0;
         end;
     end;
     for j = Ntot/2+1:Ntot  % e to u
         if Transpa(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefa*Transpa(i,j)/means,formatSpec) ,'*s*S',num2str(j),'(-1)*ap',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp = 0;
         end;
     end;
      if emp == 1           % case of empty bin
        str = ['S',num2str(i),'*',num2str(atv(i),formatSpec)]; fprintf(fid, str);
      end  
       str   = [');']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;      
     else
       str = ['at',num2str(i),' = ',num2str(atv(i),formatSpec),';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;  
    end
end;    
for i = Ntot/2+1:Ntot
   if S(i)>thres 
       str = ['at',num2str(i),' = (1/S',num2str(i),')*(\n']; fprintf(fid, str);
      emp = 1;
     for j = 1:Ntot/2 % u to e
         if Transpa(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefa*Transpa(i,j)/meanf,formatSpec),'*f*S',num2str(j),'(-1)*ap',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp =0;
         end;
     end;
     for j = Ntot/2+1:Ntot %e to E
         if Transpa(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefa*Transpa(i,j)/(1-means),formatSpec) ,'*(1-s)*S',num2str(j),'(-1)*ap',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp = 0;
         end;
     end;
    if emp==1
          str = ['S',num2str(i),'*',num2str(atv(i),formatSpec)]; fprintf(fid, str);
     end
          str = [');']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;     
    else
       str    = ['at',num2str(i),' = ',num2str(atv(i),formatSpec),';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;           
    end
end;
str = ['\n\n']; fprintf(fid, str);
%%%%%%%%%% EULER EQUATIONS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
str     = ['%%%%%%%% equation ',num2str(equa),': Euler\n\n']; fprintf(fid, str);
indc    = find(proj.ap == proj.lambdam*abar); %credit constraind agents
for   i = 1:length(indc)
    str = ['ap',num2str(indc(i)),' = abar;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;       
end;
indnc   = find(proj.ap(:)./proj.lambdam(:) > abar); % non credit constraind agents



for k = 1:length(indnc);
    i = indnc(k);
    threse = 0;
    if i <= Ntot/2
       if S(i)>thres
           str = ['S',num2str(i),'*',num2str(proj.xsiE(i),formatSpec),'*(c',num2str(i),'-( (steady_state(phi)*steady_state(l',num2str(yv(i)),'))^(1+1/phil))/(xsil*(1+1/phil)))^-sigma  = beta*(1+r(+1))*(\n'];fprintf(fid, str);
            for j = 1:Ntot/2                 % u to u and e
                 if (Transpu(i,j)>threse)    % Does agent i reach agent j ? effective transition toward the bin j
                     str = ['+',num2str(proj.Transpu(i,j)*proj.xsiE(j)/(1-meanf),formatSpec),'*(1-f(+1))*S',num2str(j),'(+1)*(c',num2str(j),'(+1)-((steady_state(phi)*steady_state(l',num2str(yv(j)),'))^(1+1/phil))/(xsil*(1+1/phil)))^-sigma\n']; fprintf(fid, str); % stay unemployed
                   
                 end;
           end;
           for j = Ntot/2+1:Ntot % u to u and e
                 if (Transpu(i,j)>threse) % Does agent i reach agent j ? effective transition toward the bin j
                     str = ['+',num2str(proj.Transpu(i,j)*proj.xsiE(j)/meanf,formatSpec),'*f(+1)*S',num2str(j),'(+1)*(c',num2str(j),'(+1)-(l',num2str(yv(j)),'(+1)^(1+1/phil))/(xsil*(1+1/phil)))^-sigma\n']; fprintf(fid, str);% becme employed          
                 end;
           end;
            str = ['+',num2str(proj.er(i),formatSpec),');']; fprintf(fid, str);
            str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;     
       else
            str = ['c',num2str(i),' = ',num2str(proj.c(i)/proj.lambda(i),formatSpec),';']; fprintf(fid, str);    str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;       
      end
    end;
     if i > Ntot/2
       if S(i)>thres
           str = ['S',num2str(i),'*',num2str(proj.xsiE(i),formatSpec),'*(c',num2str(i),'-( (l',num2str(yv(i)),')^(1+1/phil))/(xsil*(1+1/phil)))^-sigma   = beta*(1+r(+1))*(\n'];fprintf(fid, str);
           for j=1:Ntot/2
                 if (Transpu(i,j)>threse) % Does agent i reach agent j ? effective transition toward the bin j
                     str = ['+',num2str(Transpu(i,j)*proj.xsiE(j)/means,formatSpec),'*s(+1)*S',num2str(j),'(+1)*(c',num2str(j),'(+1)-((steady_state(phi)*steady_state(l',num2str(yv(j)),'))^(1+1/phil))/(xsil*(1+1/phil)))^-sigma\n']; fprintf(fid, str); % stay unemployed
                 end;
           end;
           for j = Ntot/2+1:Ntot
                 if (Transpu(i,j)>threse) % Does agent i reach agent j ? effective transition toward the bin j
                      str = ['+',num2str(Transpu(i,j)*proj.xsiE(j)/(1-means),formatSpec) ,'*(1-s(+1))*S',num2str(j),'(+1)*(c',num2str(j),'(+1)-(l',num2str(yv(j)),'(+1)^(1+1/phil))/(xsil*(1+1/phil)))^-sigma\n']; fprintf(fid, str);% becme employed
                 end;
           end;
             str = ['+',num2str(proj.er(i),formatSpec),');']; fprintf(fid, str);
            str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;   
       else
            str    = ['c',num2str(i),' = ',num2str(proj.c(i)/proj.lambda(i),formatSpec),';']; fprintf(fid, str);
            str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
       end
    end;  
end;
%%%%%%%%%%%%%%%%%%%%%%%%%  SHARES  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
str    = [' %%%%%%%% equation ',num2str(equa),': Shares \n\n']; fprintf(fid, str); 
thres2 = thres;
for i  = 1:Ntot/2 
   emp = 1;
   str = ['S',num2str(i),' = \n']; fprintf(fid, str);
     for j = 1:Ntot/2
         if proj.Transp(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefS*proj.Transp(i,j)/(1-meanf),formatSpec),'*(1-f)*S',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp = 0;
         end; 
     end;
     for j       = Ntot/2+1:Ntot
         if proj.Transp(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefS*proj.Transp(i,j)/means,formatSpec) ,'*s*S',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp = 0;
         end;
     end;
     
     if emp ==1   % case where small bin with no transition
          str    = [num2str(proj.lambda(i),formatSpec) ,';']; fprintf(fid, str);
     else
          str  = [';']; fprintf(fid, str);   
     end;
     str       = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;   
end;     
for i = Ntot/2+1:Ntot
    emp = 1;
     str       = ['S',num2str(i),' = ']; fprintf(fid, str);
     for     j = 1:Ntot/2
         if proj.Transp(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
           str = ['+',num2str(coefS*proj.Transp(i,j)/meanf,formatSpec),'*f*S',num2str(j),'(-1)\n']; fprintf(fid, str);
           emp = 0;
         end;
     end;
     for     j = Ntot/2+1:Ntot
        if proj.Transp(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
           str = ['+',num2str(coefS*proj.Transp(i,j)/(1-means),formatSpec),'*(1-s)*S',num2str(j),'(-1)\n']; fprintf(fid, str); 
           emp = 0;
         end;
     end;
    
      if emp ==1   % case where small bin with no transition
           str = [num2str(proj.lambda(i),formatSpec) ,';']; fprintf(fid, str);
      else
           str = [';']; fprintf(fid, str);
      end;
      str      = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;   
end; 
str            = ['\n\n']; fprintf(fid, str);
thres          = thres2;
%%%%%%%%%%%%%%%%%%%%%  AGGREGATIONS  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
str             = [' %%%%%%%% equation ',num2str(equa),': Aggretations \n\n']; fprintf(fid, str);
str             = ['Pop = ']; fprintf(fid, str);
for           i = 1:Ntot
     str    = ['+S',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
            str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str             = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;  
str             = ['K = ']; fprintf(fid, str);
for           i = 1:Ntot
     str    = ['+S',num2str(i),'*ap',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str             = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;  

str             = ['Ku = ']; fprintf(fid, str);
for           i = 1:Ntot/2
    str         = ['+S',num2str(i),'*ap',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str    = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str             = [';'] ;          fprintf(fid, str);str = ['\n\n']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;   

str = ['L2 = ']; fprintf(fid, str);
for i = Ntot/2+1:Ntot
     str    = ['+S',num2str(i),'*',num2str(bewley.ex(yv(i))),'*l',num2str(yv(i))]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;
%str = ['U = ',num2str(bewley.Urec)]; fprintf(fid, str);
str = ['U = ']; fprintf(fid, str);
for i = 1:Ntot/2
     str    = ['+S',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;

str = ['Cu = ']; fprintf(fid, str);
for i = 1:Ntot/2
      str    = ['+S',num2str(i),'*c',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;



str = ['Incu = (1/U)*( ']; fprintf(fid, str);
for i = 1:Ntot/2
      %str    = ['+S',num2str(i),'*(0*phi*w*',num2str(bewley.ex(yv(i)),formatSpec),'*l',num2str(yv(i)),' + (1+r)*at',num2str(i),')']; fprintf(fid, str);
      str    = ['+S',num2str(i),'*(1+r)*at',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [');'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;



%%% Here log case
str = ['Ce = ']; fprintf(fid, str);
for i = Ntot/2+1:Ntot
      str    = ['+S',num2str(i),'*c',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'];fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;
str = ['C = Ce + Cu;'] ;        fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;
str = ['ratio = cuc/cec;'] ;      fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;
str = ['cec = Ce/(1-U);'] ;     fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1; 
str = ['cuc = Cu/U;'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1; 
str = ['kuc = Ku/U;'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1; 
str = ['w = (1 - alpha)*(Z^(1/(1-alpha)))*((r + delta)/alpha)^(alpha/(alpha-1));']; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['(r + delta)/(alpha*Z) = (K(-1)/L)^(alpha-1);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['Z = exp(u);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['GDP = Z*(K(-1)^alpha)*(L^(1-alpha));']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;   
str = ['f =',num2str(fcor(1),formatSpec),' + ',num2str(fcor(2),formatSpec),'*u +',num2str(fcor(3),formatSpec),'*u(-1) ;\n'] ;fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;  
str = ['L =',num2str(Lcor(1),formatSpec),' + ',num2str(Lcor(2),formatSpec),'*u;\n'] ;fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;  
str = ['u =', num2str(epscor(2),formatSpec),'*u(-1) + eps ;\n'] ;fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;  
str = ['L = L(-1)*(1 - s) + (1- L(-1))*f;\n'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;  
str = ['du = 100*u;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['dY = 100*(GDP - steady_state(GDP))/steady_state(GDP);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['dK = 100*(K - steady_state(K))/steady_state(K);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['dC = 100*(C - steady_state(C))/steady_state(C);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['dL = 100*(L - steady_state(L))/steady_state(L);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['Ineq = 100*(ratio - steady_state(ratio))/steady_state(ratio);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['df = 100*(f- steady_state(f));']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['dU = 100*(U- steady_state(U));']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['dphi = 100*(phi- steady_state(phi));']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['I = K - (1 - delta)*K(-1);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LGDP = log(GDP);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LC   = log(C);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LI   = log(I);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LL   = log(L);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['Lw   = log(w);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['phi = tau*(1-U)/U;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['end;\n\n'] ; fprintf(fid, str);  


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
str = ['%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'] ; fprintf(fid, str);   
str = ['\n\n'] ; fprintf(fid, str);    

%str = ['initval;\n\n'] ; fprintf(fid, str);    
str = ['steady_state_model;\n\n'] ; fprintf(fid, str);           
for i = 1:Ntot
    str = ['ap',num2str(i),' = ',num2str(apv(i),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['at',num2str(i),' = ',num2str(atv(i),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['c',num2str(i), ' = ',num2str(proj.cv(i),formatSpec),';\n'] ; fprintf(fid, str); 
    str = ['S',num2str(i), ' = ',num2str(proj.lambda(i),formatSpec),';\n'] ; fprintf(fid, str); 
    
end;

for i = 1:proj.nx
    str = ['l',num2str(i),' =  ',num2str(proj.ls(i),formatSpec),';\n']; fprintf(fid, str);
end;

str = ['r = ', num2str(proj.r,formatSpec),';\n'] ; fprintf(fid, str);
str = ['K = ', num2str(bewley.meanA,formatSpec),';\n'] ; fprintf(fid, str);
str = ['L = ', num2str(bewley.meanL,formatSpec),';\n'] ; fprintf(fid, str);
str = ['w = ', num2str(bewley.wage,formatSpec),';\n'] ; fprintf(fid, str);
str = ['tau','    = ',num2str(bewley.tau,formatSpec),';\n\n']; fprintf(fid, str);
str = ['Z  = 1;\n\n']; fprintf(fid, str);
str = ['u  = 0;\n\n']; fprintf(fid, str);
str = ['GDP = Z*K^alpha*L^(1-alpha);\n']; fprintf(fid, str);
str = ['Pop = 1;\n']; fprintf(fid, str);


UU  = S(1:Ntot/2)'*bewley.ex(yv(1:Ntot/2));
str = ['U = ',num2str(UU,formatSpec),';\n']; fprintf(fid, str);
 
str = ['s =',num2str(means,formatSpec),';\n'] ; fprintf(fid, str);  
str = ['f =',num2str(meanf,formatSpec),';\n'] ; fprintf(fid, str);  
str = ['Cu = ']; fprintf(fid, str);
for i = 1:Ntot/2
      str    = ['+S',num2str(i),'*c',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'] ;         fprintf(fid, str);str = [' \n\n']; 
str = ['Ce = ']; fprintf(fid, str);
for i = Ntot/2+1:Ntot
      str    = ['+S',num2str(i),'*c',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'];fprintf(fid, str);str = [' \n\n']; fprintf(fid, str); 
str = ['C = Ce + Cu;'] ;         fprintf(fid, str);str = [' \n\n']; fprintf(fid, str); 
str = ['cec = Ce/(1-U);'] ;      fprintf(fid, str);str = ['\n\n']; fprintf(fid, str); 
str = ['cuc = Cu/U;'] ;          fprintf(fid, str);str = ['\n\n']; fprintf(fid, str); 
str = ['ratio = cuc/cec;'] ;       fprintf(fid, str);str = [' \n\n']; fprintf(fid, str); 


%str = ['DIF = steady_state(DIF);']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1; % steady-state operator to avoid 
str = ['Ku = ']; fprintf(fid, str);
for i = 1:Ntot/2
     str    = ['+S',num2str(i),'*ap',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'] ;          fprintf(fid, str);str = ['\n\n']; fprintf(fid, str); 

str = ['Incu = (1/U)*( ']; fprintf(fid, str);
for i = 1:Ntot/2
      %str    = ['+S',num2str(i),'*(0*phi*w*',num2str(bewley.ex(yv(i)),formatSpec),'*l',num2str(yv(i)),' + (1+r)*at',num2str(i),')']; fprintf(fid, str);
      str    = ['+S',num2str(i),'*(1+r)*at',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [');\n'] ;         fprintf(fid, str);
str = ['kuc = Ku/U;\n'] ;         fprintf(fid, str);
str = ['du = 0;\n']; fprintf(fid, str); 
str = ['dY = 0;\n']; fprintf(fid, str); 
str = ['dK = 0;\n']; fprintf(fid, str); 
str = ['dC = 0;\n']; fprintf(fid, str); 
str = ['dL = 0;\n']; fprintf(fid, str); 
str = ['Ineq = 0;\n']; fprintf(fid, str); 
str = ['df = 0;\n']; fprintf(fid, str); 
str = ['dU = 0;\n']; fprintf(fid, str); 
str = ['dphi = 0;\n']; fprintf(fid, str); 
str = ['I =  delta*K;\n']; fprintf(fid, str); 
lle = (bewley.xsil*(1-bewley.tau)*bewley.ex*bewley.wage).^bewley.phil;
if bewley.sigma == 1
    U           = @(C,l) log(C - (l.^(1+1/bewley.phil))/(xsil*(1+1/phil)));
else
    U          = @(C,l) (((C - (l.^(1+1/phil))/(xsil*(1+1/phil)))).^(1-bewley.sigma))/(1-bewley.sigma);
end


if proj.method ==1
      Lsp                      = [bewley.b*kron(lle',ones(Nbin/2,1)),kron(lle',ones(Nbin/2,1))];%explicit
elseif proj.method ==2
    Lsp                       = [bewley.b*kron(lle',ones(Nbin,1)),kron(lle',ones(Nbin,1))];%implict
end;
 
str = ['LGDP = log(GDP);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LC   = log(C);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LI   = log(I);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LL   = log(L);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['Lw   = log(w);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['L2 =',num2str(Lcor(1),formatSpec),' + ',num2str(Lcor(2),formatSpec),'*1;\n'] ; fprintf(fid, str);   
str = ['end;\n\n'] ; fprintf(fid, str);     
str = ['resid;\n\n'] ; fprintf(fid, str);    
str = ['steady(nocheck);\n\n'] ; fprintf(fid, str); 
str = ['shocks;\n var eps; stderr ',num2str(sigma_u,formatSpec),';\n end;\n'] ; fprintf(fid, str);         
if periods ==0
    str = ['stoch_simul (order=1,nograph,irf=120)  GDP L C K w r s f u;'] ; fprintf(fid, str);    
else 
    str = ['stoch_simul (order=1,irf=120, nograph,periods=',num2str(periods),')  GDP L C K w r s f u;'] ; fprintf(fid, str);    
end;




    
    
    